'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _chalk = require('chalk');

var _chalk2 = _interopRequireDefault(_chalk);

var _ = require('../');

var _ramda = require('ramda');

var _helpers = require('../helpers');

var _stepDefinitions = require('./step-definitions');

var _stepDefinitions2 = _interopRequireDefault(_stepDefinitions);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { return step("next", value); }, function (err) { return step("throw", err); }); } } return step("next"); }); }; }

var runScenario = (0, _ramda.curry)(function () {
  var ref = _asyncToGenerator(regeneratorRuntime.mark(function _callee(stepDefs, scenario) {
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            console.log('\n');
            console.log(_chalk2.default.green('  Scenario: ', scenario.name));
            _context.next = 4;
            return _.browser.init({ browserName: 'chrome' });

          case 4:
            _context.next = 6;
            return (0, _helpers.serial)(runStep(stepDefs), scenario.steps);

          case 6:
            return _context.abrupt('return', _.browser.end());

          case 7:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, undefined);
  }));

  return function (_x, _x2) {
    return ref.apply(this, arguments);
  };
}());

var applyStepdef = function applyStepdef(_ref, _ref2) {
  var _ref3 = _slicedToArray(_ref, 2);

  var regex = _ref3[0];
  var handler = _ref3[1];
  var text = _ref2.text;
  return handler.apply(undefined, _toConsumableArray((0, _ramda.tail)(regex.exec(text))));
};

var runStep = (0, _ramda.curry)(function () {
  var ref = _asyncToGenerator(regeneratorRuntime.mark(function _callee2(stepDefs, step) {
    var stepDef;
    return regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            stepDef = (0, _ramda.find)(function (_ref4) {
              var _ref5 = _slicedToArray(_ref4, 1);

              var regex = _ref5[0];
              return (0, _ramda.test)(regex, step.text);
            }, stepDefs);

            if (stepDef) {
              _context2.next = 3;
              break;
            }

            return _context2.abrupt('return', console.log(_chalk2.default.yellow('No step definition for ', step.keyword, step.text)));

          case 3:
            _context2.next = 5;
            return applyStepdef(stepDef, step);

          case 5:
            _context2.next = 7;
            return _.browser.chain(function () {
              return null;
            });

          case 7:
            console.log(_chalk2.default.green('    ', step.keyword + step.text));

          case 8:
          case 'end':
            return _context2.stop();
        }
      }
    }, _callee2, undefined);
  }));

  return function (_x3, _x4) {
    return ref.apply(this, arguments);
  };
}());

exports.default = (0, _ramda.curry)(function () {
  var ref = _asyncToGenerator(regeneratorRuntime.mark(function _callee3(config, _ref6) {
    var _ref7 = _slicedToArray(_ref6, 2);

    var featurePath = _ref7[0];
    var feature = _ref7[1].feature;
    var stepDefs, scenarios;
    return regeneratorRuntime.wrap(function _callee3$(_context3) {
      while (1) {
        switch (_context3.prev = _context3.next) {
          case 0:
            stepDefs = (0, _stepDefinitions2.default)(featurePath);
            scenarios = (0, _ramda.filter)((0, _helpers.matchesTags)(config.tags), feature.children);
            return _context3.abrupt('return', (0, _helpers.serial)(runScenario(stepDefs), scenarios));

          case 3:
          case 'end':
            return _context3.stop();
        }
      }
    }, _callee3, undefined);
  }));

  return function (_x5, _x6) {
    return ref.apply(this, arguments);
  };
}());