'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.joinPath = exports.serial = exports.featureMatchesTags = exports.matchesTags = exports.log = undefined;

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _ramda = require('ramda');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var log = exports.log = function log(key) {
  return function (value) {
    console.log(key, value);
    return value;
  };
};

var matchesTags = exports.matchesTags = (0, _ramda.curry)(function (selectedTags, _ref) {
  var tags = _ref.tags;

  var _blacklist = (0, _ramda.filter)((0, _ramda.test)(/^~/), selectedTags);
  var whitelist = (0, _ramda.difference)(selectedTags, _blacklist);
  var blacklist = (0, _ramda.map)(_ramda.tail, _blacklist);

  return (0, _ramda.all)(function (_ref2) {
    var name = _ref2.name;
    return !(0, _ramda.contains)(name, blacklist);
  }, tags) && ((0, _ramda.isEmpty)(whitelist) || (0, _ramda.any)(function (_ref3) {
    var name = _ref3.name;
    return (0, _ramda.contains)(name, whitelist);
  }, tags));
});

var featureMatchesTags = exports.featureMatchesTags = (0, _ramda.curry)(function (tags, _ref4) {
  var _ref5 = _slicedToArray(_ref4, 2);

  var x = _ref5[0];
  var feature = _ref5[1].feature;

  return matchesTags(tags, feature) || (0, _ramda.any)(matchesTags(tags), feature.children);
});

var serial = exports.serial = function serial(f) {
  var list = arguments.length <= 1 || arguments[1] === undefined ? [] : arguments[1];
  return list.reduce(function (promise, e) {
    return promise.then(function () {
      return f(e);
    });
  }, Promise.resolve());
};

// String -> String
var joinPath = exports.joinPath = (0, _ramda.curry)(function (a, b) {
  return _path2.default.join(a, b);
});