'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _assert = require('assert');

var _assert2 = _interopRequireDefault(_assert);

var _chalk = require('chalk');

var _chalk2 = _interopRequireDefault(_chalk);

var _helpers = require('./helpers');

var _loadFeatures = require('./load-features');

var _loadFeatures2 = _interopRequireDefault(_loadFeatures);

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _defaultConfig = require('./default-config');

var _defaultConfig2 = _interopRequireDefault(_defaultConfig);

var _ramda = require('ramda');

var _ = require('./');

var _feature = require('./feature');

var _feature2 = _interopRequireDefault(_feature);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { return step("next", value); }, function (err) { return step("throw", err); }); } } return step("next"); }); }; }

var success = function success() {
  return console.log(_chalk2.default.green('\n\nAll Tests Passed'));
};

var failure = function () {
  var ref = _asyncToGenerator(regeneratorRuntime.mark(function _callee(err) {
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            console.log(_chalk2.default.red('Test failed with error: ', err));
            _context.next = 3;
            return browser.kill();

          case 3:
            console.log('killed browser');
            process.exit(1);

          case 5:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, undefined);
  }));

  return function failure(_x) {
    return ref.apply(this, arguments);
  };
}();

exports.default = function () {
  var _features = (0, _loadFeatures2.default)(_.config.featureFiles);
  (0, _assert2.default)(_features.length > 0, 'Could not fund any feature files: ' + _.config.featureFiles);
  var features = (0, _ramda.filter)((0, _helpers.featureMatchesTags)(_.config.tags), _features);
  return (0, _helpers.serial)((0, _feature2.default)(_.config), features).then(success, failure);
};